Index: /branches/ORCHIDEE_EXT/ORCHIDEE/src_parameters/pft_parameters.f90
===================================================================
--- /branches/ORCHIDEE_EXT/ORCHIDEE/src_parameters/pft_parameters.f90	(revision 256)
+++ /branches/ORCHIDEE_EXT/ORCHIDEE/src_parameters/pft_parameters.f90	(revision 257)
@@ -1,3 +1,3 @@
-!    09/2010
+! Version 0:   26/06/2010
 ! This is the module where we define the number of pfts and the values of the 
 ! parameters
@@ -9,4 +9,5 @@
 USE constantes
 USE ioipsl
+USE parallel
 USE defprec
 
@@ -50,4 +51,14 @@
   ! Is the vegetation type a tree ?
   LOGICAL,ALLOCATABLE, SAVE, DIMENSION (:) :: is_tree
+  !>> DS new for merge in the trunk   ! 15/06/2011 
+  ! Add for writing history files in stomate_lpj.f90 'treeFracPrimDec' and 'treeFracPrimEver'
+  ! is PFT deciduous ?
+  LOGICAL,ALLOCATABLE, SAVE, DIMENSION (:) :: is_deciduous
+  LOGICAL,ALLOCATABLE, SAVE, DIMENSION (:) :: is_evergreen
+  LOGICAL,ALLOCATABLE, SAVE, DIMENSION (:) :: is_c3
+  ! used in diffuco   !! Nathalie le 28 mars 2006 - sur proposition de Fred Hourdin, ajout
+  !! d'un potentiometre pour regler la resistance de la vegetation
+  REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:)      ::  rveg_pft
+
   !-
   ! 2 .Stomate
@@ -61,4 +72,71 @@
   LOGICAL, ALLOCATABLE, SAVE, DIMENSION (:) :: natural
 
+  !-------------------------------
+  ! Evapotranspiration -  sechiba
+  !-------------------------------
+  !-
+  ! Structural resistance.
+  ! Value for rstruct_const : one for each vegetation type
+  REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:) :: rstruct_const
+  !
+  ! A vegetation dependent constant used in the calculation
+  ! of the surface resistance.
+  ! Value for kzero one for each vegetation type
+  REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:) :: kzero  
+
+
+  !-------------------
+  ! Water - sechiba
+  !-------------------
+  !-
+  ! Maximum field capacity for each of the vegetations (Temporary).
+  ! Value of wmax_veg : max quantity of water :
+  ! one for each vegetation type en Kg/M3
+  REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:) :: wmax_veg
+  ! Root profile description for the different vegetation types.
+  ! These are the factor in the exponential which gets
+  ! the root density as a function of depth
+  REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:) :: humcste
+  ! used in hydrolc
+  REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:)   :: throughfall_by_pft
+
+
+  !------------------
+  ! Albedo - sechiba
+  !------------------
+  !-
+  ! Initial snow albedo value for each vegetation type
+  ! as it will be used in condveg_snow
+  ! Values are from the Thesis of S. Chalita (1992)
+  REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:) :: snowa_ini
+  !
+  ! Decay rate of snow albedo value for each vegetation type
+  ! as it will be used in condveg_snow
+  ! Values are from the Thesis of S. Chalita (1992)
+  REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:) :: snowa_dec
+  !
+  ! leaf albedo of vegetation type, visible albedo
+  REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:) :: alb_leaf_vis
+  ! leaf albedo of vegetation type, near infrared albedo
+  REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:) :: alb_leaf_nir
+  ! leaf albedo of vegetation type, VIS+NIR
+  REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:) :: alb_leaf
+
+
+  !------------------------
+  !   Soil - vegetation
+  !------------------------
+  !
+  ! Table which contains the correlation between the soil types
+  ! and vegetation type. Two modes exist :
+  !  1) pref_soil_veg = 0 then we have an equidistribution
+  !     of vegetation on soil types
+  !  2) Else for each pft the prefered soil type is given :
+  !     1=sand, 2=loan, 3=clay
+  ! The variable is initialized in slowproc.
+  INTEGER(i_std), ALLOCATABLE, SAVE, DIMENSION (:,:) :: pref_soil_veg
+  INTEGER(i_std), ALLOCATABLE, SAVE, DIMENSION (:) :: pref_soil_veg_sand
+  INTEGER(i_std), ALLOCATABLE, SAVE, DIMENSION (:) :: pref_soil_veg_loan
+  INTEGER(i_std), ALLOCATABLE, SAVE, DIMENSION (:) :: pref_soil_veg_clay
 
   !----------------
@@ -163,16 +241,14 @@
   ! for carbohydrate reserve, tabulated
   REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:) ::cm_zero_carbres
+
  
-
-
   !----------------
   ! Fire - stomate
   !----------------
-
+  !
   ! flamability: critical fraction of water holding capacity
   REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:) :: flam
   ! fire resistance
   REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:) :: resist
-
 
 
@@ -195,5 +271,4 @@
   ! 1 .Stomate
   !-
-  !
   ! maximum LAI, PFT-specific
   REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:) :: lai_max 
@@ -235,4 +310,7 @@
   REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:) :: alloc_max
   REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:) :: demi_alloc
+  !>> DS new for merge in the trunk
+  ! 15/06/2011 : add leaflife_mtc for the new formalism used for calculate sla
+  REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:) :: leaflife_tab
   !-
   ! 3. Senescence
@@ -282,73 +360,4 @@
 
 
-  !-------------------------------
-  ! Evapotranspiration -  sechiba
-  !-------------------------------
-  !-
-  ! Structural resistance.
-  ! Value for rstruct_const : one for each vegetation type
-  REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:) :: rstruct_const
-  !
-  ! A vegetation dependent constant used in the calculation
-  ! of the surface resistance.
-  ! Value for kzero one for each vegetation type
-  REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:) :: kzero  
-
-
-  !-------------------
-  ! Water - sechiba
-  !-------------------
-  !-
-  ! Maximum field capacity for each of the vegetations (Temporary).
-  ! Value of wmax_veg : max quantity of water :
-  ! one for each vegetation type en Kg/M3
-  REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:) :: wmax_veg
-  ! Root profile description for the different vegetation types.
-  ! These are the factor in the exponential which gets
-  ! the root density as a function of depth
-  REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:) :: humcste
-
-
-  !------------------
-  ! Albedo - sechiba
-  !------------------
-  !-
-  ! Initial snow albedo value for each vegetation type
-  ! as it will be used in condveg_snow
-  ! Values are from the Thesis of S. Chalita (1992)
-  REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:) :: snowa_ini
-  !
-  ! Decay rate of snow albedo value for each vegetation type
-  ! as it will be used in condveg_snow
-  ! Values are from the Thesis of S. Chalita (1992)
-  REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:) :: snowa_dec
-  !
-  ! leaf albedo of vegetation type, visible albedo
-  REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:) :: alb_leaf_vis
-  ! leaf albedo of vegetation type, near infrared albedo
-  REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:) :: alb_leaf_nir
-  ! leaf albedo of vegetation type, VIS+NIR
-  REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:) :: alb_leaf
-
-
-  !
-  !------------------------
-  !   Soil - vegetation
-  !------------------------
-
-  ! Table which contains the correlation between the soil types
-  ! and vegetation type. Two modes exist :
-  !  1) pref_soil_veg = 0 then we have an equidistribution
-  !     of vegetation on soil types
-  !  2) Else for each pft the prefered soil type is given :
-  !     1=sand, 2=loan, 3=clay
-  ! The variable is initialized in slowproc.
-  INTEGER(i_std), ALLOCATABLE, SAVE, DIMENSION (:,:) :: pref_soil_veg
-  INTEGER(i_std), ALLOCATABLE, SAVE, DIMENSION (:) :: pref_soil_veg_sand
-  INTEGER(i_std), ALLOCATABLE, SAVE, DIMENSION (:) :: pref_soil_veg_loan
-  INTEGER(i_std), ALLOCATABLE, SAVE, DIMENSION (:) :: pref_soil_veg_clay
-
-
-  !
   !--------------------------------------------
   ! Internal parameters used in stomate_data
@@ -370,15 +379,4 @@
 
 
-  !-------------------------------
-  ! Parameters already externalised (from sechiba)
-  ! to classify
-  !----------------------------------
-  !
-  ! used in hydrolc and hydrol
-  REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:)   :: throughfall_by_pft
-  ! used in diffuco   !! Nathalie le 28 mars 2006 - sur proposition de Fred Hourdin, ajout
-  !! d'un potentiometre pour regler la resistance de la vegetation
-  REAL(r_std), ALLOCATABLE, SAVE, DIMENSION (:)      ::  rveg_pft
-
 
 CONTAINS
@@ -397,18 +395,24 @@
    IF(l_first_define_pft) THEN
 
+      ! 1. First time step
       IF(long_print) THEN
          WRITE(numout,*) 'l_first_define_pft :we read the parameters from the def files'
       ENDIF
 
+      ! 2. Memory allocation
       ! Allocation of memory for the pfts-parameters
       CALL pft_parameters_alloc
 
+      ! 3. Correspondance table 
+      
+      ! 3.1 Initialisation of the correspondance table
       ! Initialisation of the correspondance table
       pft_to_mtc (:) = undef_integer
       
-      ! Reading of the conrrespondance table in the .def file
-      CALL getin('PFT_TO_MTC',pft_to_mtc)
-
-      ! Add the standard configuration
+      ! 3.2 Reading of the conrrespondance table in the .def file
+      CALL getin_p('PFT_TO_MTC',pft_to_mtc)
+
+      ! 3.3 If the user want to use the standard configuration, he needn't to fill the correspondance array
+      !     If the configuration is wrong, send a error message to the user.
       IF(nvm .EQ. 13 ) THEN
          IF(pft_to_mtc(1) .EQ. undef_integer) THEN
@@ -422,5 +426,7 @@
       ENDIF
 
-     ! What happened if pft_to_mtc(j) > nvmc (if the mtc doesn't exist)?
+      ! 3.4 Some error messages
+
+      ! 3.4.1 What happened if pft_to_mtc(j) > nvmc (if the mtc doesn't exist)?
        DO i = 1, nvm
           IF(pft_to_mtc(i) .GT. nvmc) THEN
@@ -431,5 +437,5 @@
 
 
-      ! Verify if pft_to_mtc(1) = 1 
+      ! 3.4.2 Check if pft_to_mtc(1) = 1 
        IF(pft_to_mtc(1) .NE. 1) THEN
           WRITE(numout,*) 'the first pft has to be the bare soil'
@@ -445,8 +451,8 @@
       
    
-      ! Initialisation of the pfts-parameters
+      ! 4.Initialisation of the pfts-parameters
       CALL pft_parameters_init
 
-      ! Could be useful : correspondance between the number of the pft
+      ! 5. A useful message to the user: correspondance between the number of the pft
       ! and the name of the associated mtc 
       DO i = 1,nvm
@@ -454,9 +460,12 @@
       ENDDO
 
-
-      !------------------------------------------------------!
-      ! Initialisation of tables 2D  which are used in the code !
-      !------------------------------------------------------!
-      !
+      ! 6. Initialisation of 2D arrays used in the code
+
+      !-alb_leaf
+      alb_leaf(:) = zero
+
+      !- pref_soil_veg 
+      pref_soil_veg(:,:) = zero_int
+
       !- pheno_gdd_crit
       pheno_gdd_crit(:,:) = zero 
@@ -470,14 +479,15 @@
       !-coeff_maint_zero
       coeff_maint_zero(:,:) = zero
-      !
-      !-alb_leaf
-      alb_leaf(:) = zero
-      !- pref_soil_veg (see slowproc)
+
+      ! 7. End message
+      IF(long_print) THEN
+         WRITE(numout,*) 'pft_parameters_done'
+      ENDIF
 
    ELSE 
 
-       l_first_define_pft = .FALSE.
+      l_first_define_pft = .FALSE.
        
-       RETURN
+      RETURN
 
    ENDIF
@@ -496,27 +506,54 @@
    !------------
 
-   ! Initialisation !! not all the parameters are initialized 
-
-   !----------------------
+   !
+   ! 1. Initialisation !! not all the parameters are initialized 
+   !
+
+   !-
    ! Vegetation structure 
-   !----------------------
-   !-
+   !-
+   !
    ! 1 .Sechiba
-   !-
+   !
    veget_ori_fixed_test_1(:) = zero
    llaimax(:) = zero
    llaimin(:) = zero
    height_presc(:) = zero
-   !-
+   rveg_pft(:) = zero
+   !
    ! 2 .Stomate
    !
    leaf_tab(:) = zero_int
    sla(:) = zero   
-   !----------------
+   !-
+   ! Evapotranspiration -  sechiba
+   !-
+   rstruct_const(:) = zero
+   kzero(:) = zero
+   !-
+   ! Water - sechiba
+   !-
+   wmax_veg(:) = zero
+   humcste(:) = zero
+   throughfall_by_pft(:) = zero
+   !-
+   ! Albedo - sechiba
+   !-
+   snowa_ini(:) = zero
+   snowa_dec(:) = zero
+   alb_leaf_vis(:) = zero
+   alb_leaf_nir(:) = zero
+   !-
+   ! Soil - vegetation
+   !-
+   pref_soil_veg_sand(:) = zero_int
+   pref_soil_veg_loan(:) = zero_int
+   pref_soil_veg_clay(:) = zero_int
+   !-
    ! Photosynthesis
-   !----------------
-   !-
+   !-
+   !
    ! 1 .CO2
-   !-
+   !
    gsslope(:) = zero
    gsoffset(:) = zero
@@ -526,8 +563,8 @@
    co2_topt_fix(:) = zero
    co2_tmax_fix(:) = zero
-   !-
+   ext_coeff(:) = zero
+   !
    ! 2 .Stomate
-   !-
-   ext_coeff(:) = zero
+   !
    vcmax_opt(:) = zero
    vjmax_opt(:) = zero
@@ -541,8 +578,7 @@
    tphoto_max_b(:) = zero
    tphoto_max_c(:) = zero
-   !----------------------
+   !-
    ! Respiration - stomate
-   !----------------------
-   !
+   !-
    maint_resp_slope_c(:) = zero
    maint_resp_slope_b(:) = zero
@@ -556,29 +592,27 @@
    cm_zero_fruit(:) = zero
    cm_zero_carbres(:) = zero
-   !----------------
+   !-
    ! Fire - stomate
-   !---------------
+   !-
    ! 
    flam(:) = zero
    resist(:) = zero
-   !----------------
+   !-
    ! Flux - LUC
-   !---------------
-   !
+   !-
    coeff_lcchange_1(:) = zero
    coeff_lcchange_10(:) = zero
    coeff_lcchange_100(:) = zero
-   !
-   !-----------
+   !-
    ! Phenology
-   !-----------
-   !-
+   !-
+   !
    ! 1 .Stomate
-   !-
+   !
    lai_max(:) = zero
    pheno_type(:) = zero_int
-   !-
+   !
    ! 2. Leaf Onset
-   !-
+   !
    pheno_gdd_crit_c(:) = zero
    pheno_gdd_crit_b(:) = zero
@@ -595,7 +629,9 @@
    alloc_max(:) = zero
    demi_alloc(:) = zero  
-   !-
+  !>> DS new for merge in the trunk 15/06/2011
+   leaflife_tab(:) = zero
+   !
    ! 3. Senescence
-   !-
+   !
    leaffall(:) = zero
    leafagecrit(:) = zero
@@ -608,39 +644,13 @@
    senescence_temp_b(:) = zero 
    senescence_temp_a(:) = zero 
-   !-----------
+   !-
    ! DGVM
-   !-----------
-   !
+   !-
    residence_time(:) = zero
    tmin_crit(:) = zero
    tcm_crit(:) = zero
-   !-------------------------------
-   ! Evapotranspiration -  sechiba
-   !-------------------------------
-   !-
-   rstruct_const(:) = zero
-   kzero(:) = zero
-   !-------------------
-   ! Water - sechiba
-   !-------------------
-   !-
-   wmax_veg(:) = zero
-   humcste(:) = zero
-   !------------------
-   ! Albedo - sechiba
-   !------------------
-   !-
-   snowa_ini(:) = zero
-   snowa_dec(:) = zero
-   alb_leaf_vis(:) = zero
-   alb_leaf_nir(:) = zero
-   !------------------------
-   !   Soil - vegetation
-   !------------------------
-   pref_soil_veg(:,:) = zero_int
-
-   !------------------------
+   !-
    !  Internal_parameters
-   !------------------------
+   !-
    lai_initmin(:) = zero
    bm_sapl(:,:) = zero
@@ -649,15 +659,9 @@
    cn_sapl(:) = zero
    leaf_timecst(:) = zero  
-   !-------------------------------
-   ! Parameters already externalised (from sechiba)
-   ! to classify
-   !----------------------------------
-   throughfall_by_pft(:) = zero
-   rveg_pft(:) = zero
-
-
-   !-------------------------------------------------------------!
-   ! Correspondance between the PFTs values and thes MTCs values !
-   !-------------------------------------------------------------!  
+
+
+   !
+   ! 2. Correspondance between the PFTs values and thes MTCs values 
+   !
  
    DO j= 1, nvm
@@ -666,10 +670,10 @@
       PFT_name(j) = MTC_name(pft_to_mtc(j))
 
-      !----------------------
+      !-
       ! Vegetation structure 
-      !----------------------
-      !-
+      !-
+      !
       ! 1 .Sechiba
-      !-
+      !
       veget_ori_fixed_test_1(j) = veget_ori_fixed_mtc(pft_to_mtc(j))
       llaimax(j) = llaimax_mtc(pft_to_mtc(j))
@@ -678,16 +682,50 @@
       type_of_lai(j) = type_of_lai_mtc(pft_to_mtc(j))
       is_tree(j) = is_tree_mtc(pft_to_mtc(j))
-      !-
+      rveg_pft(j) = rveg_mtc(pft_to_mtc(j))
+
+      !>> DS new for merge in the trunk   ! 15/06/2011 
+      ! Add for writing history files in stomate_lpj.f90 'treeFracPrimDec' and 'treeFracPrimEver'
+      is_deciduous(j) = is_deciduous_mtc(pft_to_mtc(j))
+      is_evergreen(j) = is_evergreen_mtc(pft_to_mtc(j))
+      is_c3(j) = is_c3(pft_to_mtc(j))
+
+      !
       ! 2 .Stomate
-      !- 
+      !
       leaf_tab(j) = leaf_tab_mtc(pft_to_mtc(j))
       sla(j) = sla_mtc(pft_to_mtc(j))
       natural(j) = natural_mtc(pft_to_mtc(j))
-      !----------------
+
+      !-
+      ! Evapotranspiration -  sechiba
+      !-
+      rstruct_const(j) = rstruct_const_mtc(pft_to_mtc(j))
+      kzero(j) = kzero_mtc(pft_to_mtc(j))
+      !-
+      ! Water - sechiba
+      !-
+      wmax_veg(j) = wmax_veg_mtc(pft_to_mtc(j))
+      humcste(j) = humcste_mtc(pft_to_mtc(j))
+      throughfall_by_pft(j) = throughfall_by_mtc(pft_to_mtc(j))
+      !-
+      ! Albedo - sechiba
+      !-
+      snowa_ini(j) = snowa_ini_mtc(pft_to_mtc(j))
+      snowa_dec(j) = snowa_dec_mtc(pft_to_mtc(j)) 
+      alb_leaf_vis(j) = alb_leaf_vis_mtc(pft_to_mtc(j))  
+      alb_leaf_nir(j) = alb_leaf_nir_mtc(pft_to_mtc(j))
+      !-
+      !   Soil - vegetation
+      !-
+      pref_soil_veg_sand(j) = pref_soil_veg_sand_mtc(pft_to_mtc(j))
+      pref_soil_veg_loan(j) = pref_soil_veg_loan_mtc(pft_to_mtc(j))
+      pref_soil_veg_clay(j) = pref_soil_veg_clay_mtc(pft_to_mtc(j))
+
+      !-
       ! Photosynthesis
-      !----------------
-      !-
+      !-
+      !
       ! 1 .CO2
-      !-
+      !
       is_c4(j) = is_c4_mtc(pft_to_mtc(j))
       gsslope(j) = gsslope_mtc(pft_to_mtc(j))
@@ -698,7 +736,7 @@
       co2_topt_fix(j) = co2_topt_fix_mtc(pft_to_mtc(j))
       co2_tmax_fix(j) = co2_tmax_fix_mtc(pft_to_mtc(j))
-      !-
+      !
       ! 2 .Stomate
-      !-
+      !
       ext_coeff(j) = ext_coeff_mtc(pft_to_mtc(j))
       vcmax_opt(j) = vcmax_opt_mtc(pft_to_mtc(j))
@@ -713,7 +751,7 @@
       tphoto_max_b(j) = tphoto_max_b_mtc(pft_to_mtc(j))
       tphoto_max_c(j) = tphoto_max_c_mtc(pft_to_mtc(j))
-      !----------------------
+      !-
       ! Respiration - stomate
-      !----------------------
+      !-
       maint_resp_slope_c(j) = maint_resp_slope_c_mtc(pft_to_mtc(j))               
       maint_resp_slope_b(j) = maint_resp_slope_b_mtc(pft_to_mtc(j))
@@ -727,27 +765,27 @@
       cm_zero_fruit(j) = cm_zero_fruit_mtc(pft_to_mtc(j))
       cm_zero_carbres(j) = cm_zero_carbres_mtc(pft_to_mtc(j))
-      !----------------
+      !-
       ! Fire - stomate
-      !---------------
+      !-
       flam(j) = flam_mtc(pft_to_mtc(j))
       resist(j) = resist_mtc(pft_to_mtc(j))
-      !----------------
+      !-
       ! Flux - LUC
-      !---------------
+      !-
       coeff_lcchange_1(j) = coeff_lcchange_1_mtc(pft_to_mtc(j))
       coeff_lcchange_10(j) = coeff_lcchange_10_mtc(pft_to_mtc(j))
       coeff_lcchange_100(j) = coeff_lcchange_100_mtc(pft_to_mtc(j))
-      !-----------
+      !-
       ! Phenology
-      !-----------
-      !-
+      !-
+      !
       ! 1 .Stomate
-      !-
+      !
       lai_max(j) = lai_max_mtc(pft_to_mtc(j))
       pheno_model(j) = pheno_model_mtc(pft_to_mtc(j))
       pheno_type(j) = pheno_type_mtc(pft_to_mtc(j))
-      !-
+      !
       ! 2. Leaf Onset
-      !-
+      !
       pheno_gdd_crit_c(j) = pheno_gdd_crit_c_mtc(pft_to_mtc(j))
       pheno_gdd_crit_b(j) = pheno_gdd_crit_b_mtc(pft_to_mtc(j))         
@@ -764,7 +802,9 @@
       alloc_max(j) = alloc_max_mtc(pft_to_mtc(j))
       demi_alloc(j) = demi_alloc_mtc(pft_to_mtc(j))
-      !-
+  !>> DS new for merge in the trunk   ! 15/06/2011 
+      leaflife_tab(j) = leaflife_mtc(pft_to_mtc(j))
+      !
       ! 3. Senescence
-      !-
+      !
       leaffall(j) = leaffall_mtc(pft_to_mtc(j))
       leafagecrit(j) = leafagecrit_mtc(pft_to_mtc(j))
@@ -778,46 +818,11 @@
       senescence_temp_b(j) = senescence_temp_b_mtc(pft_to_mtc(j))
       senescence_temp_a(j) = senescence_temp_a_mtc(pft_to_mtc(j))
-      !-----------
+      !-
       ! DGVM
-      !-----------
       residence_time(j) = residence_time_mtc(pft_to_mtc(j))
       tmin_crit(j) = tmin_crit_mtc(pft_to_mtc(j))
       tcm_crit(j) =  tcm_crit_mtc(pft_to_mtc(j))
       
-      !-------------------------------
-      ! Evapotranspiration -  sechiba
-      !-------------------------------
-      !-
-      rstruct_const(j) = rstruct_const_mtc(pft_to_mtc(j))
-      kzero(j) = kzero_mtc(pft_to_mtc(j))
-      !-------------------
-      ! Water - sechiba
-      !-------------------
-      !-
-      wmax_veg(j) = wmax_veg_mtc(pft_to_mtc(j))
-      humcste(j) = humcste_mtc(pft_to_mtc(j))
-      !------------------
-      ! Albedo - sechiba
-      !------------------
-      !-
-      snowa_ini(j) = snowa_ini_mtc(pft_to_mtc(j))
-      snowa_dec(j) = snowa_dec_mtc(pft_to_mtc(j)) 
-      alb_leaf_vis(j) = alb_leaf_vis_mtc(pft_to_mtc(j))  
-      alb_leaf_nir(j) = alb_leaf_nir_mtc(pft_to_mtc(j))
-      !------------------------
-      !   Soil - vegetation
-      !------------------------
-      pref_soil_veg_sand(j) = pref_soil_veg_sand_mtc(pft_to_mtc(j))
-      pref_soil_veg_loan(j) = pref_soil_veg_loan_mtc(pft_to_mtc(j))
-      pref_soil_veg_clay(j) = pref_soil_veg_clay_mtc(pft_to_mtc(j))
-      !-------------------------------
-      ! Parameters already externalised (from sechiba)
-      ! to classify
-      !---------------------------------- 
-      throughfall_by_pft(j) = throughfall_by_mtc(pft_to_mtc(j))
-      rveg_pft(j) = rveg_mtc(pft_to_mtc(j))
-
-  ! end loop over nvm    
-   ENDDO
+   ENDDO ! end loop over nvm 
 
  END SUBROUTINE pft_parameters_init
@@ -840,4 +845,16 @@
    l_error = l_error .OR. (ier .NE. 0)
    !-
+   !>> DS new for merge in the trunk   ! 15/06/2011 
+   ! Add for writing history files in stomate_lpj.f90 'treeFracPrimDec' and 'treeFracPrimEver'
+   ALLOCATE(is_deciduous(nvm),stat=ier)   
+   l_error = l_error .OR. (ier .NE. 0)
+   ALLOCATE(is_evergreen(nvm),stat=ier)  
+   l_error = l_error .OR. (ier .NE. 0)
+   ALLOCATE(is_c3(nvm),stat=ier)  
+   l_error = l_error .OR. (ier .NE. 0)
+   ALLOCATE(leaflife_tab(nvm),stat=ier)   
+   l_error = l_error .OR. (ier .NE. 0)
+   ! >> END
+
    ALLOCATE(veget_ori_fixed_test_1(nvm),stat=ier)
    l_error = l_error .OR. (ier .NE. 0)
@@ -1066,13 +1083,200 @@
 
  END SUBROUTINE pft_parameters_alloc
+!
+!=
+!
+ SUBROUTINE getin_sechiba_pft_parameters
+
+   IMPLICIT NONE
+  
+   LOGICAL, SAVE ::  first_call = .TRUE.
+
+  IF(first_call) THEN
+
+     ! No calling to getin for veget_ori_fixed_test_1, llaimax and height_presc
+     ! use of setvar in slowproc.f90
+
+     !-
+     ! Vegetation structure
+     !-
+     CALL getin_p('LLAIMIN',llaimin)
+     CALL getin('TYPE_OF_LAI',type_of_lai)
+     CALL getin_p('IS_TREE',is_tree)
+     CALL getin_p('NATURAL',natural)
+
+     !>> DS new for merge in the trunk   ! 15/06/2011 
+     ! Add for writing history files in stomate_lpj.f90 'treeFracPrimDec' and 'treeFracPrimEver'
+     CALL getin('IS_DECIDUOUS',is_deciduous)
+     CALL getin('IS_EVERGREEN',is_evergreen)  
+     CALL getin_p('IS_C3',is_c3)   
+
+     !-
+     ! Photosynthesis
+     !-
+     CALL getin_p('IS_C4',is_c4)
+     CALL getin_p('GSSLOPE',gsslope)
+     CALL getin_p('GSOFFSET',gsoffset)
+     CALL getin_p('VCMAX_FIX',vcmax_fix)
+     CALL getin_p('VJMAX_FIX',vjmax_fix)
+     CALL getin_p('CO2_TMIN_FIX',co2_tmin_fix)
+     CALL getin_p('CO2_TOPT_FIX',co2_topt_fix)
+     CALL getin_p('CO2_TMAX_FIX',co2_tmax_fix)
+     CALL getin_p('EXT_COEFF',ext_coeff)
+     !-
+     ! Evapotranspiration -  sechiba
+     !-
+     CALL getin_p('RSTRUCT_CONST',rstruct_const)
+     CALL getin_p('KZERO',kzero)
+     CALL getin_p('RVEG_PFT', rveg_pft)    
+     !-
+     ! Water-hydrology - sechiba
+     !-
+     CALL getin_p('WMAX_VEG',wmax_veg)
+     CALL getin_p('HYDROL_HUMCSTE', humcste)
+     CALL getin_p('PERCENT_TROUGHFALL_PFT',throughfall_by_pft)
+     !-
+     ! Albedo - sechiba
+     !-
+     CALL getin_p('SNOWA_INI',snowa_ini)
+     CALL getin_p('SNOWA_DEC',snowa_dec)
+     CALL getin_p('ALB_LEAF_VIS',alb_leaf_vis)
+     CALL getin_p('ALB_LEAF_NIR',alb_leaf_nir)
+     !-
+     ! Soil - vegetation
+     !-
+     CALL getin_p('PREF_SOIL_VEG_SAND',pref_soil_veg_sand)
+     CALL getin_p('PREF_SOIL_VEG_LOAN',pref_soil_veg_loan)         
+     CALL getin_p('PREF_SOIL_VEG_CLAY',pref_soil_veg_clay)
+
+     first_call = .FALSE.
+
+  ENDIF
+
+END SUBROUTINE getin_sechiba_pft_parameters
+!
+!=
+!
+SUBROUTINE getin_stomate_pft_parameters
+
+  IMPLICIT NONE
+
+  LOGICAL, SAVE ::  first_call = .TRUE.
+
+  IF(first_call) THEN
+
+      !-
+      ! Vegetation structure
+      !-
+      CALL getin_p('LEAF_TAB',leaf_tab)
+      CALL getin_p('SLA',sla)
+      !-
+      ! Photosynthesis
+      !-
+      CALL getin_p('VCMAX_OPT',vcmax_opt)
+      CALL getin_p('VJMAX_OPT',vjmax_opt)
+      CALL getin_p('TPHOTO_MIN_A',tphoto_min_a)
+      CALL getin_p('TPHOTO_MIN_B',tphoto_min_b)
+      CALL getin_p('TPHOTO_MIN_C',tphoto_min_c)
+      CALL getin_p('TPHOTO_OPT_A',tphoto_opt_a)
+      CALL getin_p('TPHOTO_OPT_B',tphoto_opt_b)
+      CALL getin_p('TPHOTO_OPT_C',tphoto_opt_c)
+      CALL getin_p('TPHOTO_MAX_A',tphoto_max_a)
+      CALL getin_p('TPHOTO_MAX_B',tphoto_max_b)
+      CALL getin_p('TPHOTO_MAX_C',tphoto_max_c)
+      !-
+      ! Respiration - stomate
+      !-
+      CALL getin_p('MAINT_RESP_SLOPE_C',maint_resp_slope_c) 
+      CALL getin_p('MAINT_RESP_SLOPE_B',maint_resp_slope_b)
+      CALL getin_p('MAINT_RESP_SLOPE_A',maint_resp_slope_a)
+      CALL getin_p('CM_ZERO_LEAF',cm_zero_leaf)
+      CALL getin_p('CM_ZERO_SAPABOVE',cm_zero_sapabove)
+      CALL getin_p('CM_ZERO_SAPBELOW',cm_zero_sapbelow)
+      CALL getin_p('CM_ZERO_HEARTABOVE',cm_zero_heartabove)
+      CALL getin_p('CM_ZERO_HEARTBELOW',cm_zero_heartbelow)
+      CALL getin_p('CM_ZERO_ROOT',cm_zero_root)
+      CALL getin_p('CM_ZERO_FRUIT',cm_zero_fruit)
+      CALL getin_p('CM_ZERO_CARBRES',cm_zero_carbres)
+      !-
+      ! Fire - stomate
+      !-
+      CALL getin_p('FLAM',flam)
+      CALL getin_p('RESIST',resist)
+      !-
+      ! Flux - LUC
+      !-
+      CALL getin_p('COEFF_LCCHANGE_1',coeff_lcchange_1)
+      CALL getin_p('COEFF_LCCHANGE_10',coeff_lcchange_10)
+      CALL getin_p('COEFF_LCCHANGE_100',coeff_lcchange_100)
+      !-
+      ! Phenology
+      !-
+      CALL getin_p('LAI_MAX',lai_max)
+      CALL getin('PHENO_MODEL',pheno_model)
+      CALL getin_p('PHENO_TYPE',pheno_type)
+      !-
+      ! Phenology : Leaf Onset
+      !-
+      CALL getin_p('PHENO_GDD_CRIT_C',pheno_gdd_crit_c)
+      CALL getin_p('PHENO_GDD_CRIT_B',pheno_gdd_crit_b)
+      CALL getin_p('PHENO_GDD_CRIT_A',pheno_gdd_crit_a)
+      CALL getin_p('NGD_CRIT',ngd_crit)
+      CALL getin_p('NCDGDD_TEMP', ncdgdd_temp)
+      CALL getin_p('HUM_FRAC', hum_frac)
+      CALL getin_p('LOWGPP_TIME', lowgpp_time)
+      CALL getin_p('HUM_MIN_TIME', hum_min_time)
+      CALL getin_p('TAU_SAP',tau_sap)
+      CALL getin_p('TAU_FRUIT',tau_fruit)
+      CALL getin_p('ECUREUIL',ecureuil)
+      CALL getin_p('ALLOC_MIN',alloc_min)
+      CALL getin_p('ALLOC_MAX',alloc_max)
+      CALL getin_p('DEMI_ALLOC',demi_alloc)
+
+      !>> DS new for merge in the trunk
+      ! 15/06/2011 : add leaflife_mtc for the new formalism used for calculate sla
+      CALL getin_p('LEAFLIFE_TAB',leaflife_tab)
+
+      !-
+      ! Phenology : Senescence
+      !-
+      CALL getin_p('LEAFFALL',leaffall)
+      CALL getin_p('LEAFAGECRIT',leafagecrit)  
+      CALL getin('SENESCENCE_TYPE', senescence_type) 
+      CALL getin_p('SENESCENCE_HUM', senescence_hum)
+      CALL getin_p('NOSENESCENCE_HUM', nosenescence_hum) 
+      CALL getin_p('MAX_TURNOVER_TIME',max_turnover_time)
+      CALL getin_p('MIN_TURNOVER_TIME',min_turnover_time)
+      CALL getin_p('MIN_LEAF_AGE_FOR_SENESCENCE', min_leaf_age_for_senescence)
+      CALL getin_p('SENESCENCE_TEMP_C',senescence_temp_c)
+      CALL getin_p('SENESCENCE_TEMP_B',senescence_temp_b)
+      CALL getin_p('SENESCENCE_TEMP_A',senescence_temp_a)
+      !-
+      ! DGVM
+      !-
+      CALL getin_p('RESIDENCE_TIME',residence_time)
+      CALL getin_p('TMIN_CRIT',tmin_crit)
+      CALL getin_p('TCM_CRIT',tcm_crit)
+      
+     first_call = .FALSE.
+       
+  ENDIF
+  
+END SUBROUTINE getin_stomate_pft_parameters
  !
  !=
  !
  SUBROUTINE pft_parameters_clear
-
+   
    l_first_define_pft = .TRUE.
-
+   
    IF(ALLOCATED(pft_to_mtc))DEALLOCATE(pft_to_mtc)
    IF(ALLOCATED(PFT_name))DEALLOCATE(PFT_name)
+   !-
+   !>> DS new for merge in the trunk   ! 15/06/2011 
+   ! Add for writing history files in stomate_lpj.f90 'treeFracPrimDec' and 'treeFracPrimEver'
+   IF(ALLOCATED(is_deciduous))DEALLOCATE(is_deciduous)
+   IF(ALLOCATED(is_evergreen))DEALLOCATE(is_evergreen)
+   IF(ALLOCATED(leaflife_tab))DEALLOCATE(leaflife_tab)
+   IF(ALLOCATED(is_c3))DEALLOCATE(is_c3)  
    !-
    IF(ALLOCATED(veget_ori_fixed_test_1))DEALLOCATE(veget_ori_fixed_test_1)   
